﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;  // Подключение модуля для рисования

namespace lab4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            dataGridView1.Rows.Add(5);   //добавление 5 строк
        }

        string[] Valuta = { "Англ фунт стерлингов", "Канадский доллар", "Доллар США", "Норвежская крона", "Датская крона" };
        double[] Kurs = { 45.30, 28.90, 27.80, 5.08, 5.34 };
        double[] Vznoc = new double[5];
        int[] Stavka = { 5, 4, 6, 2, 3 };
        double[] Komis = new double[5];
        double[] SumR = new double[5];
        private void button2_Click(object sender, EventArgs e) // Расчет комиссионных и суммы выдачи
        {
            try                          //охраняемый блок
            {
                if (double.Parse(textBox1.Text) > 0) // работа только с положительными числами
                {
                    for (int i = 0; i < 5; i++)
                    {
                        dataGridView1.Rows[i].Cells[0].Value = Valuta[i];
                        dataGridView1.Rows[i].Cells[1].Value = Kurs[i];
                        dataGridView1.Rows[i].Cells[2].Value = textBox1.Text;
                        Vznoc[i] = System.Convert.ToDouble(dataGridView1.Rows[i].Cells[2].Value);
                        dataGridView1.Rows[i].Cells[3].Value = Stavka[i];
                        Komis[i] = Vznoc[i] * Stavka[i] / 100;
                        dataGridView1.Rows[i].Cells[4].Value = Komis[i];
                        SumR[i] = (Vznoc[i] - Komis[i]) / Kurs[i];
                        dataGridView1.Rows[i].Cells[5].Value = SumR[i];
                    }
                }
                else MessageBox.Show("Надо вводить положительные цифры ", "Ошибочный ввод данных", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            catch
            {
                MessageBox.Show("Надо вводить положительные цифры ", "Ошибочный ввод данных", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void button1_Click(object sender, EventArgs e)  //Очистка столбцов от данных
        {
            for (int i = 0; i < 5; i++)
            {
                dataGridView1.Rows[i].Cells[2].Value = " ";
                dataGridView1.Rows[i].Cells[4].Value = " ";
                dataGridView1.Rows[i].Cells[5].Value = " ";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int mx = 500; int a = 300;          //длина оси х  и отступ для заголовка диаграммы
            int x0 = 40; int y0 = 500;	        //начала координат
            int[] h = new int[5];               //массив столбцов
            int wc = 40; int dc = 25;           //ширина столбцов и расстояние между столбцами
            int m = 0;                          //номер столбца с максимальным значением
            for (int i = 1; i < 5; i++)
                if (SumR[i] > SumR[m]) m = i;   //поиск максимального значения
            for (int i = 0; i < 5; i++)         //расчет столбцов диаграммы с их масштабированием
                h[i] = (int)Math.Round((y0 - a) * SumR[i] / SumR[m]);  //нормирование высоты столбцов
            Graphics g = Graphics.FromHwnd(this.Handle);  // рисуем        
            Pen pen = new Pen(Color.Black);     //карандашом черного цвета

            g.DrawString("Диаграмма конверсии валют разных стран", new Font("Arial", 14), Brushes.Lime, 100, a - 50);                     // вывод заголовка диаграммы
            g.DrawLine(pen, x0, y0, x0, y0 - h[m]);  //Рисуем ось Y 
            g.DrawLine(pen, x0, y0, x0 + mx, y0);    //Рисуем ось Х 
            x0 = x0 + dc;                          //отступ первого столбца
            Brush brush = Brushes.Lime;   // заливка столбцов

            for (int i = 0; i < 5; i++) // Вывод столбцов с надписью валюты для каждого столбца
            {
                g.FillRectangle(brush, x0, y0 - h[i], wc, h[i]);     //заливка прямоугольной области
                g.DrawRectangle(pen, new Rectangle(x0, y0 - h[i], wc, h[i])); //прямоугольная область
                g.DrawString(String.Format("{0:f2}", SumR[i]) + " у.е.", new Font("Arial", 10), Brushes.Black, x0, y0 - h[i] - 20);       //вывод надписи над столбцами
                x0 = x0 + wc + dc;        //подготовка к следующему столбцу
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            double sum = 0;
            for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                sum = sum + Convert.ToDouble(dataGridView1.Rows[i].Cells[4].Value);
            label2.Text = "Ответ: \n" + "Средний комиссионный сбор  = " + Convert.ToString(sum / (dataGridView1.RowCount - 1));
        }

        private void button5_Click(object sender, EventArgs e)
        {
            DataGridViewColumn ColumnS;
            ListSortDirection direction;
            ColumnS = dataGridView1.Columns[5];
            direction = ListSortDirection.Descending;
            dataGridView1.Sort(ColumnS, direction);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            double val;
            bool find = false;
            for (int i = 0; i < dataGridView1.RowCount; i++)
            {
                val = Convert.ToDouble(dataGridView1.Rows[i].Cells[1].Value);
                if (val == Convert.ToDouble(textBox2.Text))
                {
                    MessageBox.Show("Совпадение с элементом под номером " + (i + 1), "Поиск курса рубля успешен", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    find = true;
                }
            }
            if (find == false)
                MessageBox.Show("Совпадение отсутствует ", "Ошибочный ввод данных", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}
